## net.sf.saxon.expr
Interface StaticContext

All Known Subinterfaces:
  XPathStaticContext, XSLTStaticContext

All Known Implementing Classes:
  AbstractStaticContext, ExpressionContext, IndependentContext, JAXPXPathStaticContext, QueryModule, UseWhenStaticContext

    public interface StaticContext

A StaticContext contains the information needed while an expression or pattern is being parsed. The information is also sometimes needed at run-time.

Method Summary
`VariableReference` `bindVariable(StructuredQName qName)` Bind a variable used in this element to the XSLVariable element in which it is declared
`java.lang.String` `getBaseURI()` Get the Base URI of the stylesheet element, for resolving any relative URI's used in the expression.
`StringCollator` `getCollation(java.lang.String name)` Get a named collation.
`Configuration` `getConfiguration()` Get the system configuration
`java.lang.String` `getDefaultCollationName()` Get the name of the default collation.
`java.lang.String` `getDefaultElementNamespace()` Get the default XPath namespace for elements and types
`java.lang.String` `getDefaultFunctionNamespace()` Get the default function namespace
`FunctionLibrary` `getFunctionLibrary()` Get the function library containing all the in-scope functions available in this static context
`java.util.Set` `getImportedSchemaNamespaces()` Get the set of imported schemas
`int` `getLineNumber()` Get the line number of the expression within its containing entity Returns -1 if no line number is available
`LocationMap` `getLocationMap()` Get the location map.
`NamePool` `getNamePool()` Get the NamePool used for compiling expressions
`NamespaceResolver` `getNamespaceResolver()` Get a namespace resolver to resolve the namespaces declared in this static context.
`java.lang.String` `getSystemId()` Get the System ID of the container of the expression.
`java.lang.String` `getURIForPrefix(java.lang.String prefix)` Get the URI for a namespace prefix.
`boolean` `isAllowedBuiltInType(BuiltInAtomicType type)` Determine whether a built-in type is available in this context.
`boolean` `isImportedSchema(java.lang.String namespace)` Determine whether a Schema for a given target namespace has been imported.
`boolean` `isInBackwardsCompatibleMode()` Determine whether Backwards Compatible Mode is used
`void` `issueWarning(java.lang.String message, javax.xml.transform.SourceLocator locator)` Issue a compile-time warning.
`XPathContext` `makeEarlyEvaluationContext()` Construct a dynamic context for early evaluation of constant subexpressions.

Method Detail

### getConfiguration

    Configuration getConfiguration()

  Get the system configuration

  Returns:
    the Saxon configuration

### makeEarlyEvaluationContext

    XPathContext makeEarlyEvaluationContext()

  Construct a dynamic context for early evaluation of constant subexpressions.

  Returns:
    a newly constructed dynamic context

### getLocationMap

    LocationMap getLocationMap()

  Get the location map. This is a mapping from short location ids held with each expression or subexpression, to a fully-resolved location in a source stylesheet or query.

  Returns:
    the location map

### issueWarning

    void issueWarning(java.lang.String message,
                      javax.xml.transform.SourceLocator locator)

  Issue a compile-time warning.

  Parameters:
    `message` - The warning message. This should not contain any prefix such as "Warning".
    `locator` - the location of the construct in question. May be null.

### getSystemId

    java.lang.String getSystemId()

  Get the System ID of the container of the expression. This is the containing entity (file) and is therefore useful for diagnostics. Use getBaseURI() to get the base URI, which may be different.

  Returns:
    the system ID

### getLineNumber

    int getLineNumber()

  Get the line number of the expression within its containing entity Returns -1 if no line number is available

  Returns:
    the line number, or -1 if not available

### getBaseURI

    java.lang.String getBaseURI()

  Get the Base URI of the stylesheet element, for resolving any relative URI's used in the expression. Used by the document(), doc(), resolve-uri(), and base-uri() functions. May return null if the base URI is not known.

  Returns:
    the static base URI, or null if not known

### getURIForPrefix

    java.lang.String getURIForPrefix(java.lang.String prefix)
                                     throws XPathException

  Get the URI for a namespace prefix. The default namespace is NOT used when the prefix is empty.

  Parameters:
    `prefix` - The namespace prefix.
  Returns:
    the corresponding namespace URI
  Throws:
    `XPathException` - if the prefix is not declared

### getNamePool

    NamePool getNamePool()

  Get the NamePool used for compiling expressions

  Returns:
    the name pool

### bindVariable

    VariableReference bindVariable(StructuredQName qName)
                                   throws XPathException

  Bind a variable used in this element to the XSLVariable element in which it is declared

  Parameters:
    `qName` - The name of the variable
  Returns:
    a VariableReference representing the variable reference, suitably initialized to refer to the corresponding variable declaration
  Throws:
    `XPathException`

### getFunctionLibrary

    FunctionLibrary getFunctionLibrary()

  Get the function library containing all the in-scope functions available in this static context

  Returns:
    the function library

### getCollation

    StringCollator getCollation(java.lang.String name)

  Get a named collation.

  Parameters:
    `name` - The name of the required collation. Supply null to get the default collation.
  Returns:
    the collation; or null if the required collation is not found.

### getDefaultCollationName

    java.lang.String getDefaultCollationName()

  Get the name of the default collation.

  Returns:
    the name of the default collation; or the name of the codepoint collation if no default collation has been defined

### getDefaultElementNamespace

    java.lang.String getDefaultElementNamespace()

  Get the default XPath namespace for elements and types

  Returns:
    the default namespace, or NamespaceConstant.NULL for the non-namespace

### getDefaultFunctionNamespace

    java.lang.String getDefaultFunctionNamespace()

  Get the default function namespace

  Returns:
    the default namespace for function names

### isInBackwardsCompatibleMode

    boolean isInBackwardsCompatibleMode()

  Determine whether Backwards Compatible Mode is used

  Returns:
    true if running in XPath 1.0 compatibility mode

### isImportedSchema

    boolean isImportedSchema(java.lang.String namespace)

  Determine whether a Schema for a given target namespace has been imported. Note that the in-scope element declarations, attribute declarations and schema types are the types registered with the (schema-aware) configuration, provided that their namespace URI is registered in the static context as being an imported schema namespace. (A consequence of this is that within a Configuration, there can only be one schema for any given namespace, including the null namespace).

  Parameters:
    `namespace` - the target namespace in question
  Returns:
    true if the given namespace has been imported

### getImportedSchemaNamespaces

    java.util.Set getImportedSchemaNamespaces()

  Get the set of imported schemas

  Returns:
    a Set, the set of URIs representing the names of imported schemas

### isAllowedBuiltInType

    boolean isAllowedBuiltInType(BuiltInAtomicType type)

  Determine whether a built-in type is available in this context. This method caters for differences between host languages as to which set of types are built in.

  Parameters:
    `type` - the supposedly built-in type. This will always be a type in the XS or XDT namespace.
  Returns:
    true if this type can be used in this static context

### getNamespaceResolver

    NamespaceResolver getNamespaceResolver()

  Get a namespace resolver to resolve the namespaces declared in this static context.

  Returns:
    a namespace resolver.

Copyright (c) Saxonica Limited. All rights reserved.